import Vue from 'vue';
import Component from 'vue-class-component';
import {Watch} from 'vue-property-decorator';
import JournalItem from '@/repository/JournalItem';
@Component
export class DataTableDialogActions extends Vue {

    get formTitle() {
            return this.editedIndex === -1 ? this.newRecordLabel : this.editRecordLabel;
    }
    public newRecordLabel: string = 'Новая запись';
    public editRecordLabel: string = 'Изменить запись';
    public defaultItem: JournalItem = {
        fullName: '',
        id: 0,
        orderDate: '',
        orderNumber: '',
        orderTypeId: 0,
        reasonId: 0,
        orderType: '',
        reason: '',
        c_osn: ''
    };
    public editedIndex: number = -1;
    public dialog: boolean = false;
    public editedItem: JournalItem = this.defaultItem;
    public tableItems: JournalItem[] = [];

    public editItem(item: JournalItem) {
        this.editedIndex = this.tableItems.indexOf(item);
        this.editedItem = Object.assign({}, item);
        this.dialog = true;
    }

    public close() {
        this.dialog = false;
        setTimeout(() => {
            this.editedItem = Object.assign({}, this.defaultItem);
            this.editedIndex = -1;
        }, 300);
    }

    public save() {
        if (this.editedIndex > -1) {
            Object.assign(this.tableItems[this.editedIndex], this.editedItem);
        } else {
            this.tableItems.push(this.editedItem);
        }
        this.close();
    }
    @Watch('dialog')
    public onDialogChange(val: any) {
        return val || this.close();
    }
}

export default DataTableDialogActions;
